;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; UrForth level 1: self-hosting 32-bit Forth compiler
;; Copyright (C) 2020 Ketmar Dark // Invisible Vector
;; GPLv3 ONLY
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
[IFNDEF] forth:utf
vocabulary utf
[ENDIF]

also utf definitions


create (koi->uni)
0x0000 w, 0x0001 w, 0x0002 w, 0x0003 w, 0x0004 w, 0x0005 w, 0x0006 w, 0x0007 w, 0x0008 w, 0x0009 w, 0x000a w, 0x000b w, 0x000c w, 0x000d w, 0x000e w, 0x000f w,
0x0010 w, 0x0011 w, 0x0012 w, 0x0013 w, 0x0014 w, 0x0015 w, 0x0016 w, 0x0017 w, 0x0018 w, 0x0019 w, 0x001a w, 0x001b w, 0x001c w, 0x001d w, 0x001e w, 0x001f w,
0x0020 w, 0x0021 w, 0x0022 w, 0x0023 w, 0x0024 w, 0x0025 w, 0x0026 w, 0x0027 w, 0x0028 w, 0x0029 w, 0x002a w, 0x002b w, 0x002c w, 0x002d w, 0x002e w, 0x002f w,
0x0030 w, 0x0031 w, 0x0032 w, 0x0033 w, 0x0034 w, 0x0035 w, 0x0036 w, 0x0037 w, 0x0038 w, 0x0039 w, 0x003a w, 0x003b w, 0x003c w, 0x003d w, 0x003e w, 0x003f w,
0x0040 w, 0x0041 w, 0x0042 w, 0x0043 w, 0x0044 w, 0x0045 w, 0x0046 w, 0x0047 w, 0x0048 w, 0x0049 w, 0x004a w, 0x004b w, 0x004c w, 0x004d w, 0x004e w, 0x004f w,
0x0050 w, 0x0051 w, 0x0052 w, 0x0053 w, 0x0054 w, 0x0055 w, 0x0056 w, 0x0057 w, 0x0058 w, 0x0059 w, 0x005a w, 0x005b w, 0x005c w, 0x005d w, 0x005e w, 0x005f w,
0x0060 w, 0x0061 w, 0x0062 w, 0x0063 w, 0x0064 w, 0x0065 w, 0x0066 w, 0x0067 w, 0x0068 w, 0x0069 w, 0x006a w, 0x006b w, 0x006c w, 0x006d w, 0x006e w, 0x006f w,
0x0070 w, 0x0071 w, 0x0072 w, 0x0073 w, 0x0074 w, 0x0075 w, 0x0076 w, 0x0077 w, 0x0078 w, 0x0079 w, 0x007a w, 0x007b w, 0x007c w, 0x007d w, 0x007e w, 0x007f w,
0x2500 w, 0x2502 w, 0x250c w, 0x2510 w, 0x2514 w, 0x2518 w, 0x251c w, 0x2524 w, 0x252c w, 0x2534 w, 0x253c w, 0x2580 w, 0x2584 w, 0x2588 w, 0x258c w, 0x2590 w,
0x2591 w, 0x2592 w, 0x2593 w, 0x2320 w, 0x25a0 w, 0x2219 w, 0x221a w, 0x2248 w, 0x2264 w, 0x2265 w, 0x00a0 w, 0x2321 w, 0x00b0 w, 0x00b2 w, 0x00b7 w, 0x00f7 w,
0x2550 w, 0x2551 w, 0x2552 w, 0x0451 w, 0x0454 w, 0x2554 w, 0x0456 w, 0x0457 w, 0x2557 w, 0x2558 w, 0x2559 w, 0x255a w, 0x255b w, 0x0491 w, 0x255d w, 0x255e w,
0x255f w, 0x2560 w, 0x2561 w, 0x0401 w, 0x0404 w, 0x2563 w, 0x0406 w, 0x0407 w, 0x2566 w, 0x2567 w, 0x2568 w, 0x2569 w, 0x256a w, 0x0490 w, 0x256c w, 0x00a9 w,
0x044e w, 0x0430 w, 0x0431 w, 0x0446 w, 0x0434 w, 0x0435 w, 0x0444 w, 0x0433 w, 0x0445 w, 0x0438 w, 0x0439 w, 0x043a w, 0x043b w, 0x043c w, 0x043d w, 0x043e w,
0x043f w, 0x044f w, 0x0440 w, 0x0441 w, 0x0442 w, 0x0443 w, 0x0436 w, 0x0432 w, 0x044c w, 0x044b w, 0x0437 w, 0x0448 w, 0x044d w, 0x0449 w, 0x0447 w, 0x044a w,
0x042e w, 0x0410 w, 0x0411 w, 0x0426 w, 0x0414 w, 0x0415 w, 0x0424 w, 0x0413 w, 0x0425 w, 0x0418 w, 0x0419 w, 0x041a w, 0x041b w, 0x041c w, 0x041d w, 0x041e w,
0x041f w, 0x042f w, 0x0420 w, 0x0421 w, 0x0422 w, 0x0423 w, 0x0416 w, 0x0412 w, 0x042c w, 0x042b w, 0x0417 w, 0x0428 w, 0x042d w, 0x0429 w, 0x0427 w, 0x042a w,
create;

: koi->uni  ( ch -- unich )  0xff and (koi->uni) + w@ ;


create (uni->koi-ctbl0)
0xe1 c, 0xe2 c, 0xf7 c, 0xe7 c, 0xe4 c, 0xe5 c, 0xf6 c, 0xfa c, 0xe9 c, 0xea c, 0xeb c, 0xec c, 0xed c, 0xee c, 0xef c, 0xf0 c,
0xf2 c, 0xf3 c, 0xf4 c, 0xf5 c, 0xe6 c, 0xe8 c, 0xe3 c, 0xfe c, 0xfb c, 0xfd c, 0xff c, 0xf9 c, 0xf8 c, 0xfc c, 0xe0 c, 0xf1 c,
0xc1 c, 0xc2 c, 0xd7 c, 0xc7 c, 0xc4 c, 0xc5 c, 0xd6 c, 0xda c, 0xc9 c, 0xca c, 0xcb c, 0xcc c, 0xcd c, 0xce c, 0xcf c, 0xd0 c,
0xd2 c, 0xd3 c, 0xd4 c, 0xd5 c, 0xc6 c, 0xc8 c, 0xc3 c, 0xde c, 0xdb c, 0xdd c, 0xdf c, 0xd9 c, 0xd8 c, 0xdc c, 0xc0 c, 0xd1 c,
create;

create (uni->koi-ctbl1)
0xa8 c, 0xa9 c, 0xaa c, 0xab c, 0xac c,
create;

create (uni->koi-ctbl2)
0xae c, 0xaf c, 0xb0 c, 0xb1 c, 0xb2 c,
create;

create (uni->koi-ctbl3)
0xb8 c, 0xb9 c, 0xba c, 0xbb c, 0xbc c,
create;

create (uni->koi-ctbl4)
0x8f c, 0x90 c, 0x91 c, 0x92 c,
create;

: uni->koi  ( unich -- ch )
  dup case
    128 u<of 0xff and endof
    0x0410 0x044f bounds-of 0x410 - (uni->koi-ctbl0) + c@ endof
    0x00a0 of 0x9a endof
    0x00a9 of 0xbf endof
    0x00b0 of 0x9c endof
    0x00b2 of 0x9d endof
    0x00b7 of 0x9e endof
    0x00f7 of 0x9f endof
    0x0401 of 0xb3 endof
    0x0404 of 0xb4 endof
    0x0406 of 0xb6 endof
    0x0407 of 0xb7 endof
    0x0451 of 0xa3 endof
    0x0454 of 0xa4 endof
    0x0456 of 0xa6 endof
    0x0457 of 0xa7 endof
    0x0490 of 0xbd endof
    0x0491 of 0xad endof
    0x2219 of 0x95 endof
    0x221a of 0x96 endof
    0x2248 of 0x97 endof
    0x2264 of 0x98 endof
    0x2265 of 0x99 endof
    0x2320 of 0x93 endof
    0x2321 of 0x9b endof
    0x2500 of 0x80 endof
    0x2502 of 0x81 endof
    0x250c of 0x82 endof
    0x2510 of 0x83 endof
    0x2514 of 0x84 endof
    0x2518 of 0x85 endof
    0x251c of 0x86 endof
    0x2524 of 0x87 endof
    0x252c of 0x88 endof
    0x2534 of 0x89 endof
    0x253c of 0x8a endof
    0x2550 of 0xa0 endof
    0x2551 of 0xa1 endof
    0x2552 of 0xa2 endof
    0x2554 of 0xa5 endof
    0x2563 of 0xb5 endof
    0x256c of 0xbe endof
    0x2580 of 0x8b endof
    0x2584 of 0x8c endof
    0x2588 of 0x8d endof
    0x258c of 0x8e endof
    0x25a0 of 0x94 endof
    0x2557 0x255b bounds-of 0x2557 - (uni->koi-ctbl1) + c@ endof
    0x255d 0x2561 bounds-of 0x255d - (uni->koi-ctbl2) + c@ endof
    0x2566 0x256a bounds-of 0x2566 - (uni->koi-ctbl3) + c@ endof
    0x2590 0x2593 bounds-of 0x2590 - (uni->koi-ctbl4) + c@ endof
    otherwise 2drop [char] ?
  endcase
;


create (cp866->koi)
  0x00 c, 0x01 c, 0x02 c, 0x03 c, 0x04 c, 0x05 c, 0x06 c, 0x07 c, 0x08 c, 0x09 c, 0x0a c, 0x0b c, 0x0c c, 0x0d c, 0x0e c, 0x0f c,
  0x10 c, 0x11 c, 0x12 c, 0x13 c, 0x14 c, 0x15 c, 0x16 c, 0x17 c, 0x18 c, 0x19 c, 0x1a c, 0x1b c, 0x1c c, 0x1d c, 0x1e c, 0x1f c,
  0x20 c, 0x21 c, 0x22 c, 0x23 c, 0x24 c, 0x25 c, 0x26 c, 0x27 c, 0x28 c, 0x29 c, 0x2a c, 0x2b c, 0x2c c, 0x2d c, 0x2e c, 0x2f c,
  0x30 c, 0x31 c, 0x32 c, 0x33 c, 0x34 c, 0x35 c, 0x36 c, 0x37 c, 0x38 c, 0x39 c, 0x3a c, 0x3b c, 0x3c c, 0x3d c, 0x3e c, 0x3f c,
  0x40 c, 0x41 c, 0x42 c, 0x43 c, 0x44 c, 0x45 c, 0x46 c, 0x47 c, 0x48 c, 0x49 c, 0x4a c, 0x4b c, 0x4c c, 0x4d c, 0x4e c, 0x4f c,
  0x50 c, 0x51 c, 0x52 c, 0x53 c, 0x54 c, 0x55 c, 0x56 c, 0x57 c, 0x58 c, 0x59 c, 0x5a c, 0x5b c, 0x5c c, 0x5d c, 0x5e c, 0x5f c,
  0x60 c, 0x61 c, 0x62 c, 0x63 c, 0x64 c, 0x65 c, 0x66 c, 0x67 c, 0x68 c, 0x69 c, 0x6a c, 0x6b c, 0x6c c, 0x6d c, 0x6e c, 0x6f c,
  0x70 c, 0x71 c, 0x72 c, 0x73 c, 0x74 c, 0x75 c, 0x76 c, 0x77 c, 0x78 c, 0x79 c, 0x7a c, 0x7b c, 0x7c c, 0x7d c, 0x7e c, 0x7f c,
  0xe1 c, 0xe2 c, 0xf7 c, 0xe7 c, 0xe4 c, 0xe5 c, 0xf6 c, 0xfa c, 0xe9 c, 0xea c, 0xeb c, 0xec c, 0xed c, 0xee c, 0xef c, 0xf0 c,
  0xf2 c, 0xf3 c, 0xf4 c, 0xf5 c, 0xe6 c, 0xe8 c, 0xe3 c, 0xfe c, 0xfb c, 0xfd c, 0xff c, 0xf9 c, 0xf8 c, 0xfc c, 0xe0 c, 0xf1 c,
  0xc1 c, 0xc2 c, 0xd7 c, 0xc7 c, 0xc4 c, 0xc5 c, 0xd6 c, 0xda c, 0xc9 c, 0xca c, 0xcb c, 0xcc c, 0xcd c, 0xce c, 0xcf c, 0xd0 c,
  0x90 c, 0x91 c, 0x92 c, 0x81 c, 0x87 c, 0xb2 c, 0x3f c, 0x3f c, 0x3f c, 0xb5 c, 0xa1 c, 0xa8 c, 0xae c, 0x3f c, 0xac c, 0x83 c,
  0x84 c, 0x89 c, 0x88 c, 0x86 c, 0x80 c, 0x8a c, 0xaf c, 0xb0 c, 0xab c, 0xa5 c, 0xbb c, 0xb8 c, 0xb1 c, 0xa0 c, 0xbe c, 0xb9 c,
  0xba c, 0x3f c, 0x3f c, 0xaa c, 0xa9 c, 0xa2 c, 0x3f c, 0x3f c, 0xbc c, 0x85 c, 0x82 c, 0x8d c, 0x8c c, 0x8e c, 0x8f c, 0x8b c,
  0xd2 c, 0xd3 c, 0xd4 c, 0xd5 c, 0xc6 c, 0xc8 c, 0xc3 c, 0xde c, 0xdb c, 0xdd c, 0xdf c, 0xd9 c, 0xd8 c, 0xdc c, 0xc0 c, 0xd1 c,
  0xb3 c, 0xa3 c, 0xb4 c, 0xa4 c, 0xb7 c, 0xa7 c, 0x3f c, 0x3f c, 0x9c c, 0x95 c, 0x9e c, 0x96 c, 0x3f c, 0x3f c, 0x94 c, 0x9a c,
create;

: cp866->koi  ( ch -- ch )  0xff and (cp866->koi) + c@ ;


create (cp1251->koi)
  0x00 c, 0x01 c, 0x02 c, 0x03 c, 0x04 c, 0x05 c, 0x06 c, 0x07 c, 0x08 c, 0x09 c, 0x0a c, 0x0b c, 0x0c c, 0x0d c, 0x0e c, 0x0f c,
  0x10 c, 0x11 c, 0x12 c, 0x13 c, 0x14 c, 0x15 c, 0x16 c, 0x17 c, 0x18 c, 0x19 c, 0x1a c, 0x1b c, 0x1c c, 0x1d c, 0x1e c, 0x1f c,
  0x20 c, 0x21 c, 0x22 c, 0x23 c, 0x24 c, 0x25 c, 0x26 c, 0x27 c, 0x28 c, 0x29 c, 0x2a c, 0x2b c, 0x2c c, 0x2d c, 0x2e c, 0x2f c,
  0x30 c, 0x31 c, 0x32 c, 0x33 c, 0x34 c, 0x35 c, 0x36 c, 0x37 c, 0x38 c, 0x39 c, 0x3a c, 0x3b c, 0x3c c, 0x3d c, 0x3e c, 0x3f c,
  0x40 c, 0x41 c, 0x42 c, 0x43 c, 0x44 c, 0x45 c, 0x46 c, 0x47 c, 0x48 c, 0x49 c, 0x4a c, 0x4b c, 0x4c c, 0x4d c, 0x4e c, 0x4f c,
  0x50 c, 0x51 c, 0x52 c, 0x53 c, 0x54 c, 0x55 c, 0x56 c, 0x57 c, 0x58 c, 0x59 c, 0x5a c, 0x5b c, 0x5c c, 0x5d c, 0x5e c, 0x5f c,
  0x60 c, 0x61 c, 0x62 c, 0x63 c, 0x64 c, 0x65 c, 0x66 c, 0x67 c, 0x68 c, 0x69 c, 0x6a c, 0x6b c, 0x6c c, 0x6d c, 0x6e c, 0x6f c,
  0x70 c, 0x71 c, 0x72 c, 0x73 c, 0x74 c, 0x75 c, 0x76 c, 0x77 c, 0x78 c, 0x79 c, 0x7a c, 0x7b c, 0x7c c, 0x7d c, 0x7e c, 0x7f c,
  0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c,
  0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0x3f c,
  0x9a c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0xbd c, 0x3f c, 0x3f c, 0xb3 c, 0xbf c, 0xb4 c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0xb7 c,
  0x9c c, 0x3f c, 0xb6 c, 0xa6 c, 0xad c, 0x3f c, 0x3f c, 0x9e c, 0xa3 c, 0x3f c, 0xa4 c, 0x3f c, 0x3f c, 0x3f c, 0x3f c, 0xa7 c,
  0xe1 c, 0xe2 c, 0xf7 c, 0xe7 c, 0xe4 c, 0xe5 c, 0xf6 c, 0xfa c, 0xe9 c, 0xea c, 0xeb c, 0xec c, 0xed c, 0xee c, 0xef c, 0xf0 c,
  0xf2 c, 0xf3 c, 0xf4 c, 0xf5 c, 0xe6 c, 0xe8 c, 0xe3 c, 0xfe c, 0xfb c, 0xfd c, 0xff c, 0xf9 c, 0xf8 c, 0xfc c, 0xe0 c, 0xf1 c,
  0xc1 c, 0xc2 c, 0xd7 c, 0xc7 c, 0xc4 c, 0xc5 c, 0xd6 c, 0xda c, 0xc9 c, 0xca c, 0xcb c, 0xcc c, 0xcd c, 0xce c, 0xcf c, 0xd0 c,
  0xd2 c, 0xd3 c, 0xd4 c, 0xd5 c, 0xc6 c, 0xc8 c, 0xc3 c, 0xde c, 0xdb c, 0xdd c, 0xdf c, 0xd9 c, 0xd8 c, 0xdc c, 0xc0 c, 0xd1 c,
create;

: cp1251->koi  ( ch -- ch )  0xff and (cp1251->koi) + c@ ;


previous definitions
